import 'dart:async';
import './callback_result_listener.dart';

import 'package:flutter/services.dart';

class AllInOneSdk {
  AllInOneSdk() {
    _channel.setMethodCallHandler(_fromNative);
  }

  static const MethodChannel _channel = const MethodChannel('allinonesdk');
  CallbackResultListener? callbackResultListener;
  void startTransaction(
      String mid,
      String orderId,
      String amount,
      String txnToken,
      String callbackUrl,
      bool isStaging,
      bool restrictAppInvoke,
      CallbackResultListener listener,
      [bool enableAssist = true]) async {
    var sendMap = <String, dynamic>{
      "mid": mid,
      "orderId": orderId,
      "amount": amount,
      "txnToken": txnToken,
      "callbackUrl": callbackUrl,
      "isStaging": isStaging,
      "restrictAppInvoke": restrictAppInvoke,
      "enableAssist": enableAssist
    };
    callbackResultListener = listener;
    _channel.invokeMethod('startTransaction', sendMap);
  }

  Future<void> _fromNative(MethodCall call) async {
    if (call.method == 'success') {
      callbackResultListener?.onSuccess(call.arguments);
    } else if (call.method == 'error') {
      callbackResultListener?.onError(
          call.arguments["message"], call.arguments["value"]);
    }
  }
}
